#!/bin/sh -e
#
# $Id: build-updates.sh 16157 2019-07-12 01:38:41Z NiLuJe $
#

PKGNAME="downgrader"
PKGVER="0.1.N"

# We need kindletool (https://github.com/NiLuJe/KindleTool) in $PATH
if (( $(kindletool version | wc -l) == 1 )) ; then
	HAS_KINDLETOOL="true"
fi

if [[ "${HAS_KINDLETOOL}" != "true" ]] ; then
	echo "You need KindleTool (https://github.com/NiLuJe/KindleTool) to build this package."
	exit 1
fi

# Pickup our common stuff... We leave it in our staging wd so it ends up in the source package.
if [[ ! -d "../../Common" ]] ; then
        echo "The tree isn't checked out in full, missing the Common directory..."
        exit 1
fi
# LibOTAUtils 5
ln -f ../../Common/lib/libotautils5 ./libotautils5


## Install

# Copy the script to our working directory, to avoid storing crappy paths in the update package
ln -f ../src/install.sh ./

# Build the install package (PaperWhite to Voyage (i.e., stop at 5.6.0)), and make sure it won't even try to run on FW >= 5.6.0, because the initrd updater was hardened after that...
kindletool create ota2 -d paperwhite -d paperwhite2 -d voyage -t 2443690034 libotautils5 install.sh Update_${PKGNAME}_${PKGVER}_install.bin

## Cleanup
# Remove package specific temp stuff
rm -f ./install.sh

# Move our updates
mv -f *.bin ../
