#!/bin/sh
#
# Kindle PaperWhite Downgrader
#
# Original author: <syhily@gmail.com>
#
# $Id: install.sh 12125 2015-08-12 07:23:26Z NiLuJe $
#
##

HACKNAME="downgrader"

# Pull libOTAUtils for logging & progress handling
[ -f ./libotautils5 ] && source ./libotautils5


# Go!
otautils_update_progressbar

UPDATE_FILE_DIR="/mnt/us/official_update"

# Keep track of what we do for some useful logging...
i=0
for bin_file in ${UPDATE_FILE_DIR}/update*.bin ; do
	if [ -f "${bin_file}" ] ; then
		logmsg "I" "install" "" "daisy-chaining ${bin_file##*/} . . ."
		mv "${bin_file}" /mnt/us/
		let "i += 1"
	fi
done

otautils_update_progressbar

if [ ${i} -eq 0 ] ; then
	logmsg "I" "install" "" "no official update found, nothing will happen!"
elif [ ${i} -gt 1 ] ; then
	logmsg "I" "install" "" "multiple official updates found, here be dragons!"
else
	logmsg "I" "install" "" "here goes nothing..."
	# NOTE: Clear cc.db to avoid potential DB schema issues...
	rm -f /var/local/cc.db
	rm -f /var/local/dcm.db
	logmsg "I" "install" "" "cleared the content catalog to avoid db issues"
fi

otautils_update_progressbar

# Cleanup behind us...
rm -rf "${UPDATE_FILE_DIR}"

logmsg "I" "install" "" "done"

otautils_update_progressbar

# If we were run via MRPI, do the reboot ourselves...
if [ "$(ps -p ${PPID} -o comm=)" == "mrinstaller.sh" ] ; then
	logmsg "I" "install" "" "mrpi detected, rebooting ourselves..."

	# Handle the MRPI cleanup...
	rm -rf "/mnt/us/mrpackages/staging"

	# Remount the rootfs ro cleanly...
	sync
	/bin/mount -o remount,ro /
	sleep 5

	# And here we go...
	/sbin/reboot
fi

return 0
